<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Izg project: queue/src/queue/queue.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Izg project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_a5212ee8b6a8d592d027941e58e3651c.html">queue</a></li><li class="navelem"><a class="el" href="dir_821be63df25109e5eb77dd0f2b80706a.html">src</a></li><li class="navelem"><a class="el" href="dir_e311e002a24b0cb5a76159e0ee0c544b.html">queue</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">queue.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file contains implementation of uint32_t queue.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;assert.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &lt;<a class="el" href="queue_8h_source.html">queue/queue.h</a>&gt;</code><br />
<code>#include &lt;queue/private/element.h&gt;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a516fda1eafe0d28c0065eb77bf6706b4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a516fda1eafe0d28c0065eb77bf6706b4">queue_init</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, uint32_t elementSize)</td></tr>
<tr class="memdesc:a516fda1eafe0d28c0065eb77bf6706b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits queue.  <a href="#a516fda1eafe0d28c0065eb77bf6706b4">More...</a><br /></td></tr>
<tr class="separator:a516fda1eafe0d28c0065eb77bf6706b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7afe39f27b5b41454668b0a7b2cdb3a7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a7afe39f27b5b41454668b0a7b2cdb3a7">queue_free</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:a7afe39f27b5b41454668b0a7b2cdb3a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees queue.  <a href="#a7afe39f27b5b41454668b0a7b2cdb3a7">More...</a><br /></td></tr>
<tr class="separator:a7afe39f27b5b41454668b0a7b2cdb3a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a6a7795f59cb7fedcfcc50be8528576"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a1a6a7795f59cb7fedcfcc50be8528576">queue_empty</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:a1a6a7795f59cb7fedcfcc50be8528576"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns 1 if the queue is empty.  <a href="#a1a6a7795f59cb7fedcfcc50be8528576">More...</a><br /></td></tr>
<tr class="separator:a1a6a7795f59cb7fedcfcc50be8528576"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f98e59a17d2f8383b7254d31d9abbca"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a7f98e59a17d2f8383b7254d31d9abbca">queue_elements</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:a7f98e59a17d2f8383b7254d31d9abbca"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns the number of elements in the queue.  <a href="#a7f98e59a17d2f8383b7254d31d9abbca">More...</a><br /></td></tr>
<tr class="separator:a7f98e59a17d2f8383b7254d31d9abbca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf54b3c19a6a2ba167fbd6b593a9fc3a"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#acf54b3c19a6a2ba167fbd6b593a9fc3a">queue_elementSize</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:acf54b3c19a6a2ba167fbd6b593a9fc3a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns the element size in bytes.  <a href="#acf54b3c19a6a2ba167fbd6b593a9fc3a">More...</a><br /></td></tr>
<tr class="separator:acf54b3c19a6a2ba167fbd6b593a9fc3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d600c3a10f99c96c46b9e26f0b0943e"><td class="memItemLeft" align="right" valign="top">ErrorCode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a4d600c3a10f99c96c46b9e26f0b0943e">queue_push</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, void *const value)</td></tr>
<tr class="memdesc:a4d600c3a10f99c96c46b9e26f0b0943e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pushes a new value to the end of the queue.  <a href="#a4d600c3a10f99c96c46b9e26f0b0943e">More...</a><br /></td></tr>
<tr class="separator:a4d600c3a10f99c96c46b9e26f0b0943e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0f92e06f3ab2b58afb1953becd2d40b"><td class="memItemLeft" align="right" valign="top">ErrorCode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#ac0f92e06f3ab2b58afb1953becd2d40b">queue_pop</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, void *const value)</td></tr>
<tr class="memdesc:ac0f92e06f3ab2b58afb1953becd2d40b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pops elements from the front of the queue.  <a href="#ac0f92e06f3ab2b58afb1953becd2d40b">More...</a><br /></td></tr>
<tr class="separator:ac0f92e06f3ab2b58afb1953becd2d40b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2ea6d2b088ccb0a7bb457e64b9d259c"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#ad2ea6d2b088ccb0a7bb457e64b9d259c">queue_getEnd</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue, int end)</td></tr>
<tr class="memdesc:ad2ea6d2b088ccb0a7bb457e64b9d259c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns pointer to one of the ends of the queue.  <a href="#ad2ea6d2b088ccb0a7bb457e64b9d259c">More...</a><br /></td></tr>
<tr class="separator:ad2ea6d2b088ccb0a7bb457e64b9d259c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93afd6194f622473b8e20fe2837b545b"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a93afd6194f622473b8e20fe2837b545b">queue_front</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:a93afd6194f622473b8e20fe2837b545b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function return front element data.  <a href="#a93afd6194f622473b8e20fe2837b545b">More...</a><br /></td></tr>
<tr class="separator:a93afd6194f622473b8e20fe2837b545b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47dcc6fa3aeb68fa8e9d83965ca56b47"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8c.html#a47dcc6fa3aeb68fa8e9d83965ca56b47">queue_back</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:a47dcc6fa3aeb68fa8e9d83965ca56b47"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function return back element data.  <a href="#a47dcc6fa3aeb68fa8e9d83965ca56b47">More...</a><br /></td></tr>
<tr class="separator:a47dcc6fa3aeb68fa8e9d83965ca56b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file contains implementation of uint32_t queue. </p>
<dl class="section author"><dt>Author</dt><dd>Tomáš Milet, <a href="#" onclick="location.href='mai'+'lto:'+'imi'+'le'+'t@f'+'it'+'.vu'+'tb'+'r.c'+'z'; return false;">imile<span style="display: none;">.nosp@m.</span>t@fi<span style="display: none;">.nosp@m.</span>t.vut<span style="display: none;">.nosp@m.</span>br.c<span style="display: none;">.nosp@m.</span>z</a> </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="a47dcc6fa3aeb68fa8e9d83965ca56b47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a47dcc6fa3aeb68fa8e9d83965ca56b47">&#9670;&nbsp;</a></span>queue_back()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* queue_back </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function return back element data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>back element data or NULL if the queue is empty </dd></dl>

</div>
</div>
<a id="a7f98e59a17d2f8383b7254d31d9abbca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7f98e59a17d2f8383b7254d31d9abbca">&#9670;&nbsp;</a></span>queue_elements()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t queue_elements </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns the number of elements in the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of elements in the queue </dd></dl>

</div>
</div>
<a id="acf54b3c19a6a2ba167fbd6b593a9fc3a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf54b3c19a6a2ba167fbd6b593a9fc3a">&#9670;&nbsp;</a></span>queue_elementSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t queue_elementSize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns the element size in bytes. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>element size in bytes </dd></dl>

</div>
</div>
<a id="a1a6a7795f59cb7fedcfcc50be8528576"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1a6a7795f59cb7fedcfcc50be8528576">&#9670;&nbsp;</a></span>queue_empty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int queue_empty </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns 1 if the queue is empty. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if queue is empty, 0 otherwise </dd></dl>

</div>
</div>
<a id="a7afe39f27b5b41454668b0a7b2cdb3a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7afe39f27b5b41454668b0a7b2cdb3a7">&#9670;&nbsp;</a></span>queue_free()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void queue_free </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a93afd6194f622473b8e20fe2837b545b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93afd6194f622473b8e20fe2837b545b">&#9670;&nbsp;</a></span>queue_front()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* queue_front </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function return front element data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>front element data or NULL if the queue is empty </dd></dl>

</div>
</div>
<a id="ad2ea6d2b088ccb0a7bb457e64b9d259c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2ea6d2b088ccb0a7bb457e64b9d259c">&#9670;&nbsp;</a></span>queue_getEnd()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* queue_getEnd </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>end</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns pointer to one of the ends of the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">end</td><td>queue end</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointer to queue end element </dd></dl>

</div>
</div>
<a id="a516fda1eafe0d28c0065eb77bf6706b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a516fda1eafe0d28c0065eb77bf6706b4">&#9670;&nbsp;</a></span>queue_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void queue_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>elementSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">elementSize</td><td>size of one element in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac0f92e06f3ab2b58afb1953becd2d40b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac0f92e06f3ab2b58afb1953becd2d40b">&#9670;&nbsp;</a></span>queue_pop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ErrorCode queue_pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *const&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pops elements from the front of the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">value</td><td>the elements value of the queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>return ERR_OK on success </dd></dl>

</div>
</div>
<a id="a4d600c3a10f99c96c46b9e26f0b0943e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d600c3a10f99c96c46b9e26f0b0943e">&#9670;&nbsp;</a></span>queue_push()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ErrorCode queue_push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *const&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pushes a new value to the end of the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">value</td><td>a new value</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>return ERR_OK on success </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Apr 23 2019 13:21:21 for Izg project by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
